=encoding utf8

=head1 NAME

Mail::Transport::SMTP - transmit messages without external program

=head1 INHERITANCE

 Mail::Transport::SMTP
   is a Mail::Transport::Send
   is a Mail::Transport
   is a Mail::Reporter

=head1 SYNOPSIS

  my $sender = Mail::Transport::SMTP->new(...);
  $sender->send($message);

  $message->send(via => 'smtp');

=head1 DESCRIPTION

This module implements transport of C<Mail::Message> objects by negotiating
to the destination host directly by using the SMTP protocol, without help of
C<sendmail>, C<mail>, or other programs on the local host.

B<warning:> you may need to install Net::SMTPS, to get TLS support.

Extends L<"DESCRIPTION" in Mail::Transport::Send|Mail::Transport::Send/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Transport::Send|Mail::Transport::Send/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Transport::Send|Mail::Transport::Send/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

 -Option       --Defined in     --Default
  esmtp_options                   {}
  executable     Mail::Transport  undef
  from                            undef
  helo                            <from Net::Config>
  hostname       Mail::Transport  <from Net::Config>
  interval       Mail::Transport  30
  password                        undef
  port           Mail::Transport  25
  proxy          Mail::Transport  <from Net::Config>
  retry          Mail::Transport  <unlimited>
  smtp_debug                      false
  timeout                         120
  username                        undef
  via            Mail::Transport  'smtp'

=over 2

=item esmtp_options => \%opts

[2.116] ESMTP options to pass to Net::SMTP.  See the L<Net::SMTP>
documentation for full details. Options can also be passed at send time.
For example: C<< { XVERP => 1 } >>

=item executable => $file

=item from => $address

Allows a default sender C<$address> to be specified globally.
See L<trySend()|Mail::Transport::SMTP/"METHODS"> for full details.

=item helo => $host

The fully qualified name of the sender's C<$host> (your system) which
is used for the greeting message to the receiver.  If not specified,
Net::Config or else Net::Domain are questioned to find it.
When even these do not supply a valid name, the name of the domain in the
C<From> line of the message is assumed.

=item hostname => $host|\@hosts

=item interval => $span

=item password => $password

The password to be used with the C<username> to log in to the remote
server.

=item port => $port

=item proxy => $path

=item retry => $count|undef

=item smtp_debug => BOOLEAN

Simulate transmission: the SMTP protocol output will be sent to your screen.

=item timeout => $wait

The number of seconds to C<$wait> for a valid response from the server before
failing.

=item username => $username

Use SASL authentication to contact the remote SMTP server (RFC2554).
This C<$username> in combination with C<password> is passed as arguments
to Net::SMTP method auth.  Other forms of authentication are not
supported by Net::SMTP.  The C<username> can also be specified as an
Authen::SASL object.

=item via => CLASS|$name

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Transport::Send|Mail::Transport::Send/"Attributes">.

=head2 Sending mail

Extends L<"Sending mail" in Mail::Transport::Send|Mail::Transport::Send/"Sending mail">.

=over 4

=item $obj-E<gt>B<destinations>( $message, [$address|\@addresses] )

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<putContent>($message, $fh, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<send>($message, %options)

Inherited, see L<Mail::Transport::Send/"Sending mail">

=item $obj-E<gt>B<trySend>($message, %options)

Try to send the C<$message> once.   This may fail, in which case this
method will return C<false>.  In list context, the reason for failure
can be caught: in list context C<trySend> will return a list of
six values:

  (success, rc, rc-text, error location, quit success, accept)

Success and quit success are booleans.  The error code and -text are
protocol specific codes and texts.  The location tells where the
problem occurred.

[3.003] the 'accept' returns the message of the L<dataend()> instruction.
Some servers may provide useful information in there, like an internal
message registration id.  For example, postfix may return "2.0.0 Ok:
queued as 303EA380EE".  You can only use this parameter when running
local delivery (which is a smart choice anyway)
Improves base, see L<Mail::Transport::Send/"Sending mail">

 -Option       --Default
  esmtp_options  +{}
  from           < >
  to             []

=over 2

=item esmtp_options => \%opts

Additional or overridden EMSTP options. See L<new(esmtp_options)|Mail::Transport::SMTP/"METHODS">

=item from => $address

Your own identification.  This may be fake.  If not specified, it is
taken from L<Mail::Message::sender()|Mail::Message/"The header">, which means the content of the
C<Sender> field of the message or the first address of the C<From>
field.  This defaults to "E<lt> E<gt>", which represents "no address".

=item to => $address|\@addresses

Alternative destinations.  If not specified, the C<To>, C<Cc> and C<Bcc>
fields of the header are used.  An C<$address> is a string or a L<Mail::Address|Mail::Address>
object.

=back

=back

=head2 Server connection

Extends L<"Server connection" in Mail::Transport::Send|Mail::Transport::Send/"Server connection">.

=over 4

=item $obj-E<gt>B<contactAnyServer>()

Creates the connection to the SMTP server.  When more than one hostname
was specified, the first which accepts a connection is taken.  An
IO::Socket::INET object is returned.

=item $obj-E<gt>B<findBinary>( $name, [@directories] )

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<remoteHost>()

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<retry>()

Inherited, see L<Mail::Transport/"Server connection">

=item $obj-E<gt>B<tryConnectTo>($host, %options)

Try to establish a connection to deliver SMTP to the specified C<$host>.  The
C<%options> are passed to the C<new> method of Net::SMTP.

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Transport::Send|Mail::Transport::Send/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Transport::Send|Mail::Transport::Send/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: authentication for $host failed.

Cast by C<contactAnyServer()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: message has no destination.

It was not possible to figure-out where the message is intended to go to.
Cast by C<destinations()>

=item Notice: no addresses found to send the message to, no connection made.

Cast by C<trySend()>

=item Warning: resent group does not specify a destination.

The message which is sent is the result of a bounce (for instance
created with L<Mail::Message::bounce()|Mail::Message::Construct::Bounce/"Constructing a message">), and therefore starts with a
C<Received> header field.  With the C<bounce>, the new destination(s)
of the message are given, which should be included as C<Resent-To>,
C<Resent-Cc>, and C<Resent-Bcc>.

The C<To>, C<Cc>, and C<Bcc> header information is only used if no
C<Received> was found.  That seems to be the best explanation of the RFC.

As alternative, you may also specify the C<to> option to some of the senders
(for instance L<Mail::Transport::SMTP::send(to)|Mail::Transport::Send/"Sending mail"> to overrule any information
found in the message itself about the destination.
Cast by C<destinations()>

=item Warning: use option `to' to overrule the destination: `To' refers to a field.

Cast by C<trySend()>

=back

=head1 SEE ALSO

This module is part of Mail-Transport version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

